library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity compteur_modulo4_tb is
end compteur_modulo4_tb;

architecture behavior of compteur_modulo4_tb is

    -- Component Declaration for the Unit Under Test (UUT)
    component compteur_modulo4
    port(
        clk : in std_logic;
        reset : in std_logic;
        count : out std_logic_vector(1 downto 0)
    );
    end component;

    -- Inputs
    signal clk : std_logic := '0';
    signal reset : std_logic := '0';

    -- Outputs
    signal count : std_logic_vector(1 downto 0);

    -- Clock period definition
    constant clk_period : time := 10 ns;

begin

    -- Instantiate the Unit Under Test (UUT)
    uut: compteur_modulo4 port map (
        clk => clk,
        reset => reset,
        count => count
    );

    -- Clock process definitions
    clk_process :process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
    end process;

    -- Stimulus process
    stim_proc: process
    begin
        -- hold reset state for 20 ns.
        reset <= '1';
        wait for 20 ns;  
        reset <= '0';

        -- insert stimulus here 
        wait for 100 ns;        

        -- Finish simulation
        wait;
    end process;

end behavior;