library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


entity compteur_modulo6 is
    port (
        I_clk         : in  std_logic;
        I_rst         : in  std_logic;
        I_block       : in  std_logic;
        O_CounterMod6 : out std_logic_vector(2 downto 0);
        O_parallel1   : out std_logic;
        O_parallel2   : out std_logic;
        O_parallel3   : out std_logic;
        O_parallel4   : out std_logic;
        O_parallel5   : out std_logic;
        O_parallel6   : out std_logic

        );

end compteur_modulo6;


architecture modulo6_a of compteur_modulo6 is

    signal SR_Counter : unsigned(2 downto 0);

begin

    mod6: process (I_clk, I_rst, I_block)
    begin
        if I_rst = '1' then
            SR_Counter <= "000";
        elsif rising_edge(I_clk) then
            if I_block = '1' then
                SR_Counter <= SR_counter;
            elsif SR_Counter = "101" then
                SR_Counter <= "000";
            else
                SR_Counter <= SR_Counter + 1;
            end if;
        end if;
    end process;

    O_CounterMod6 <= std_logic_vector(SR_Counter);

    parallel : process (SR_Counter)
    begin
        case SR_Counter is
            when "000" =>
                O_parallel1 <= '0';
                O_parallel2 <= '1';
                O_parallel3 <= '1';
                O_parallel4 <= '1';
                O_parallel5 <= '1';
                O_parallel6 <= '1';
            when "001" =>
                O_parallel1 <= '1';
                O_parallel2 <= '0';
                O_parallel3 <= '1';
                O_parallel4 <= '1';
                O_parallel5 <= '1';
                O_parallel6 <= '1';
            when "010" =>
                O_parallel1 <= '1';
                O_parallel2 <= '1';
                O_parallel3 <= '0';
                O_parallel4 <= '1';
                O_parallel5 <= '1';
                O_parallel6 <= '1';
            when "011" =>
                O_parallel1 <= '1';
                O_parallel2 <= '1';
                O_parallel3 <= '1';
                O_parallel4 <= '0';
                O_parallel5 <= '1';
                O_parallel6 <= '1';
            when "100" =>
                O_parallel1 <= '1';
                O_parallel2 <= '1';
                O_parallel3 <= '1';
                O_parallel4 <= '1';
                O_parallel5 <= '0';
                O_parallel6 <= '1';
            when "101" =>
                O_parallel1 <= '1';
                O_parallel2 <= '1';
                O_parallel3 <= '1';
                O_parallel4 <= '1';
                O_parallel5 <= '1';
                O_parallel6 <= '0';
            when others =>
                O_parallel1 <= '1';
                O_parallel2 <= '1';
                O_parallel3 <= '1';
                O_parallel4 <= '1';
                O_parallel5 <= '1';
                O_parallel6 <= '1';
        end case;
    end process parallel;
end modulo6_a;
